Last Comment Bug 648867 - Can't open new message window
: Can't open new message window
Status: RESOLVED FIXED
:
Product: SeaMonkey
Classification: Client Software
Component: General (show other bugs)
: Trunk
: Other Mac OS X
: -- normal (vote)
: seamonkey2.6
Assigned To: Ian Neal
:
Mentors:
Depends on:
Blocks: 682579
  Show dependency treegraph
 
Reported: 2011-04-10 08:42 PDT by Doug H
Modified: 2011-09-12 08:01 PDT (History)
2 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
fixed


Attachments
Add mailNavigatorOverlay to hiddenWindow (1.11 KB, patch)
2011-08-25 07:32 PDT, Ian Neal
stefanh: feedback-
Details | Diff | Review
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11] (3.00 KB, patch)
2011-08-27 10:16 PDT, Ian Neal
mnyromyr: review+
neil: superreview+
mnyromyr: feedback+
Details | Diff | Review

Description Doug H 2011-04-10 08:42:58 PDT
User-Agent:       Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; en-US; rv:1.9.1.18) Gecko/20110320 not Firefox/4.0 not Firefox/4.0
Build Identifier: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; en-US; rv:1.9.1.18) Gecko/20110320 not Firefox/4.0 not Firefox/4.0

When I have the mail window and browser window minimized (in the dock) and the seamonkey menu bar up I can't open a new message window unless i bring either the browser window or mail window up out of the dock. I go to file and there is no choice for new message.
Only new browser, tab or composer page. 

Reproducible: Always
Comment 1 Stefan [:stefanh] 2011-04-10 10:15:23 PDT
This is also true on trunk. When all windows are minimized, I think we rely on the hiddenwindow.
Comment 2 Ian Neal 2011-08-25 07:32:04 PDT
Created attachment 555729 [details] [diff] [review]
Add mailNavigatorOverlay to hiddenWindow

This patch:
* Adds mailNavigatorOverlay.xul as an overlay to hiddenWindow.xul

Could you see if this works.
The other options would be to:
* move overlaying by mailNavigatorOverlay.xul from navigator.xul to navigatorOverlay.xul
* fold mailNavigatorOverlay into navigatorOverlay.xul
Comment 3 Stefan [:stefanh] 2011-08-26 10:20:25 PDT
Comment on attachment 555729 [details] [diff] [review]
Add mailNavigatorOverlay to hiddenWindow

It works, but we have a couple of issues:

1) "Send link" in the file menu is enabled (could be disabled in hiddenWindowStartup(), see navigator.js)
2) File --> New --> Contact opens partially off-screen because of bug 356742. If this window is opened from the hiddenWindow, I think we should exclude the modal feature (modal is what makes it a sheet). Last time I checked the function was shared with Thunderbird and the problem existed there too.
3) Then I did saw a js error complaining about no content, but now I fail to reproduce it (sorry).

Should we assume that mailNews is always included? And if we have decided that it's ok to merge browser and mailNews, maybe we should just merge mailNavigatorOverlay into navigatorOverlay (like you suggested as an alternative)?

Minusing for now, since I think we need to address the issues and settle browser/mail dependencies.
Comment 4 Ian Neal 2011-08-27 10:16:00 PDT
Created attachment 556274 [details] [diff] [review]
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11]

Changes since last patch:
* move overlaying by mailNavigatorOverlay.xul from navigator.xul to navigatorOverlay.xul
* disable sendLink and sendPage (sendPage was not being disabled properly, because it was referenced as Browser:SendPage, since the original file when it was under mailnews/base/resources/content)

I would suggest that issue 2 is either dealt with using the workaround of removing modal or left until bug 356742 is fixed. I'll let Mnyromyr comment on that.
Comment 5 Karsten Düsterloh 2011-09-06 15:11:00 PDT
Comment on attachment 556274 [details] [diff] [review]
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11]

(In reply to Ian Neal from comment #4)
> I would suggest that issue 2 is either dealt with using the workaround of
> removing modal or left until bug 356742 is fixed.

It'd be better to fix bug 356742, if the misguided sheet wouldn't be visible. But a non-really-usable, non-movable, misplaced dialog is not tolerable, so a workaround would be good.

(In reply to Stefan [:stefanh] (away until September 24) from comment #3)
> 2) File --> New --> Contact opens partially off-screen because of bug
> 356742. If this window is opened from the hiddenWindow, I think we should
> exclude the modal feature (modal is what makes it a sheet).

Are you sure that "modal" is the key problem here?

Funny thing is that I had the very similar problem last week with Mnenhy on Mac: On startup of the Mnenhy js module, my beta versions open a modal,centerscreen dialog with some info. This dialog opened centered upon the upper left corner of the screen, because it gets opened before any real windows. 

The workaround was killing the centerscreen flag if the window we're calling the openDialog on (http://mxr.mozilla.org/comm-central/source/suite/mailnews/mailOverlay.js#39) has zero width.
Comment 6 Karsten Düsterloh 2011-09-06 15:30:11 PDT
See also <http://mxr.mozilla.org/comm-central/source/mozilla/xpfe/appshell/src/nsAppShellService.cpp?mark=378-381#366> (including Mac specific code parts before).
Comment 7 Karsten Düsterloh 2011-09-11 09:31:44 PDT
Comment on attachment 556274 [details] [diff] [review]
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11]

Fine by me, but I'd like Neil's architectural eye on that as well. ;-)
Comment 8 neil@parkwaycc.co.uk 2011-09-11 10:02:14 PDT
Interesting... bug 144828 moved mailNavigatorOverlay.xul to navigator, and stopped it depending on mail (without mail, or if external mailto is manually set, then it uses external mailto.) Then there's bug 108745 which moved out out of navigatorOverlay and into navigator...
Comment 9 neil@parkwaycc.co.uk 2011-09-11 10:11:16 PDT
Well, at least we don't have to worry about overlaying view source any more.
Comment 10 neil@parkwaycc.co.uk 2011-09-12 04:27:06 PDT
Comment on attachment 556274 [details] [diff] [review]
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11]

Opening the hidden window menus results in a boatload of errors :-(

Fortunately, this patch doesn't add any new ones :-)
Comment 11 Ian Neal 2011-09-12 08:00:47 PDT
Comment on attachment 556274 [details] [diff] [review]
Add mailNavigatorOverlay to navigatorOverlay [Checked in: Comment 11]

http://hg.mozilla.org/comm-central/rev/efed0a9a84bd

Note You need to log in before you can comment on or make changes to this bug.